#!/bin/bash
. `dirname $0`"/DDR_shared_functions"
CLOUD_VERSION=/etc/cloud-version
GREP=/bin/grep
AWK=/bin/awk
ECHO=/bin/echo
#Script collects cloud type of the machine. If machine is not in cloud environment, cloudType will be an emty string.

rootCloudFilesPath=/etc
#possible cloudType uniqueFiles
cloudFiles="in-azure,in-google,in-aws,in-aliyun,in-oracle,in-tencent,in-huawei"
dmi_cmd="dmidecode -t 1 2>/dev/null"
cloudType=""

if [ -f "$CLOUD_VERSION" ]; then 
   cloudType=$($GREP -m 1 "platform:" "$CLOUD_VERSION" | $AWK '{print $2}') 
   $ECHO "cloudType='$cloudType'"
	exit 0
fi



#check cloudType
IFS=','
for cloudFile in $cloudFiles
do
	if [ -f ${rootCloudFilesPath}/${cloudFile} ]
	then
		cloudType=${cloudFile//in-}
		break
	fi
done
if [ "X$cloudType" != "X" ]; then
	$ECHO "cloudType='$cloudType'"
	exit 0

fi

IFS=' '
if [ "X$cloudType" = "X" ]; then
	dmi=$($dmi_cmd);
	dmi_cmd_exit_code=$?
	if [ $dmi_cmd_exit_code -eq 0 ]; then
	
		if [ "X$dmi" != "X" ]; then 
				product=$($ECHO "$dmi" | $GREP -Po 'Product Name:\s*\K.*')
				manufacturer=$($ECHO "$dmi" | $GREP -Po 'Manufacturer:\s*\K.*')
				case $product in
					'OpenStack Nova') cloudType="OpenStack" ;;
					'OpenStack Compute') cloudType="OpenStack" ;;
					'KVM') cloudType="KVM" ;;
					'QEMU') cloudType="QEMU" ;;
					'VMware Virtual Platform') cloudType="VMware" ;;
					'Virtual Machine')  cloudType='HyperV' ;;
					'HVM domU')  cloudType='Xen' ;;           
				esac
				if [ "$manufacturer" == "QEMU" ]; then
					cloudType='KVM/QEMU'
				fi
		fi
	else
        $ECHO "Error executing dmi_cmd (Exit Code: $dmi_cmd_exit_code)"
        exit 1
    fi
fi




$ECHO "cloudType='$cloudType'"
exit 0