#!/bin/bash
. `dirname $0`"/DDR_shared_functions"
success_indicator='True'

pvdisplay=`pvdisplay | awk '{print $3}'`
# find occurances of vg_splat in pvdisplay
lines=`echo "$pvdisplay" | grep -n "vg_splat"`
line_numbers=${lines//:vg_splat/}

disks_to_check=()

# Get all vg_splat disks
for line in $line_numbers
do
	line=$(( $line - 1 ))
	disk=`echo "$pvdisplay" | sed -n ${line}p | tr -d '0123456789'`
	disks_to_check+=("$disk")
done

# check disks logical and physical sector size
for disk in "${disks_to_check[@]}"
do
        disk_sector_sizes=`fdisk -l $disk | grep -i "sector size"`

        logical_size=`echo $disk_sector_sizes | awk '{print $4}'`
        phyisical_size=`echo $disk_sector_sizes | awk '{print $7}'`

        if [ "$logical_size" != "$phyisical_size" ];
        then
                success_indicator='False'
        fi
done

$ECHO "matchingSectorSizes='${success_indicator}'"

exit 0