#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

# THIS SCRIPT IS FOR R80.X ONLY !!
# FOR OTHER VERSIONS  TEST / MODIFY THE SCRIPT



CPPROD_UTIL=$CPDIR/bin/cpprod_util
SU="/bin/su" 
PWD="/bin/pwd"
MAX_TRIES=60
SLEEP="/bin/sleep"
CAT="/bin/cat"
ECHO="/bin/echo"
CHMOD="/bin/chmod"
SED="/bin/sed"
PSQL_CLIENT="$MDS_FWDIR/bin/psql_client"
LOCAL_LOG_FILE=/opt/CPInstLog/collect_mgmtready_output.log
PS=/bin/ps
# exit codes of cpm_status.sh
CPM_NOT_RUNNING=13
CPM_FAILED_START=14

check_postgres_status()
{
	local RET=1
	local RETURN_VAL=$1
	cd $PGDIR
	$ECHO "==================================================$FWDIR/bin/psql_client -U postgres cpm -c select 1" >> /opt/DDR/collect_mgmtready_output 2>&1
	$FWDIR/bin/psql_client -U postgres cpm -c "select 1;" >> /opt/DDR/collect_mgmtready_output 2>&1
	RET=$?
	eval $RETURN_VAL="'$RET'"
}

busy_wait_check_postgres_status()
{
	local RETURN_VAL=$1
	cd $PGDIR
	TRIES=0
	local POSTGRES_STATUS_RET=1
	local QUERY_RET=1
	if [ -f /var/tmp/postgres_max_tries ];then
		MAX_TRIES=`$CAT /var/tmp/postgres_max_tries`
	fi
	while [ $POSTGRES_STATUS_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
	do
		check_postgres_status POSTGRES_STATUS_RET
		$SLEEP 1
		let TRIES=TRIES+1
	done
	TRIES=0
	if [ $POSTGRES_STATUS_RET -eq 0 ];then
		TRIES=0
		while [ $QUERY_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
		do
			$ECHO "==================================================$FWDIR/bin/psql_client -U postgres cpm -c select 1" >> /opt/DDR/collect_mgmtready_output 2>&1
			$FWDIR/bin/psql_client -U postgres cpm -c "select 1;" >> /opt/DDR/collect_mgmtready_output 2>&1
			QUERY_RET=$?
			$SLEEP 1
			let TRIES=TRIES+1
		done
	else
		# create resolve script
		$ECHO "#!/bin/bash" > /opt/DDR/resolve_permissions
		$ECHO "$CHMOD 755 $FWDIR/..; $CHMOD 755 $FWDIR/; $CHMOD 755 $FWDIR/scripts/; $CHMOD 755 $FWDIR/scripts/postgres_commands.sh;  $CHMOD 755 $CPDIR/lib; $CHMOD 755 $CPDIR/lib/libcrypto.so.1.0.0; exit 0;" >> /opt/DDR/resolve_permissions
		$CHMOD 777 /opt/DDR/resolve_permissions
		# print message to user
		$ECHO "Could not run compatibility check - run '/opt/DDR/resolve_permissions' and try again." >> /opt/DDR/collect_mgmtready_output 2>&1	
	fi		
	eval $RETURN_VAL="'$QUERY_RET'"
}

# workaround for issue in R80.10 JRE. see sk146933
touch /var/log/skip_jit_compiler

isManagement=`$CPPROD_UTIL CPPROD_GetValue FW1 FWManagement 4`
isLogServer=`$CPPROD_UTIL CPPROD_GetValue FW1 LogServer 4`
STATUS=0

# if our version is prior to R80 then this script is not relevant , return success
isVersionOlderThan "R80"
if [ $? == 0 ]; then
	$ECHO "success"
	exit 0
fi


if [ "$isManagement" == "1" -o "$isLogServer" == "1" ]; then

  # start postgres
  if [ "X$MDSDIR" != "X" ]; then
      FWDIR=$MDS_TEMPLATE
  fi
  POSTGRES_WAS_DOWN=0
  POSTGRES_STATUS=3
  
  WORK_DIR=`$PWD`
  check_postgres_status POSTGRES_STATUS
  cd $WORK_DIR
  if [ $POSTGRES_STATUS -ne 0 ]; then
	POSTGRES_WAS_DOWN=1
  fi
  if [ $POSTGRES_WAS_DOWN -eq 1 ];then
	  $ECHO "==================================================$FWDIR/scripts/postgres_start.sh" >> /opt/DDR/collect_mgmtready_output 2>&1
	  $FWDIR/scripts/postgres_start.sh  >> /opt/DDR/collect_mgmtready_output 2>&1
	  POSTGRES_STATUS=3
	  busy_wait_check_postgres_status POSTGRES_STATUS
	  cd $WORK_DIR
	  if [ $POSTGRES_STATUS -ne 0 ]; then
		  $ECHO "Failed to start postgres. See /opt/DDR/collect_mgmtready_output for more information."
		  exit 0
	  fi
  fi
  
  internal_failure_msg="Failed to collect verification parameters. Please try again."

  #dump all stderr to log file
  exec 2>$LOCAL_LOG_FILE

  getFatherProcessID (){    
		fatherPpidReturn=`ps -p $1 -o ppid=`
		if [ $? -ne 0 -o "X$fatherPpidReturn" = "X" ]; then
			$ECHO "Failed to get process $1 parent PID..." >> $LOCAL_LOG_FILE 
			$ECHO "output=\"$internal_failure_msg\""
			$ECHO "fatherPpidReturn=$fatherPpidReturn" >> $LOCAL_LOG_FILE
			exit 0
		fi
  }
  #initialization of global varibale fatherPpidReturn
  fatherPpidReturn=-1
  
  #make sure we receive the full output of ps commands
  COLUMNS=300

  $ECHO "Running $0 " `date` >> $LOCAL_LOG_FILE 
  #find the path to conditions_set_is_ngm_upgrade.json


  getFatherProcessID $$
  ppid=$fatherPpidReturn

  getFatherProcessID $ppid
  gppid=$fatherPpidReturn

  gppidArgs=$($PS -o args= -p $gppid)
  if [ $? -ne 0 -o "X$gppidArgs" = "X" ]; then
	$ECHO "$PS -o args= -p $gppid" >> $LOCAL_LOG_FILE  
	$ECHO "output=\"$internal_failure_msg\""
	exit 0
  fi
  metadataPathArg=$($ECHO $gppidArgs | $CUT -f3 -d\ | $SED "s/--path_to_metadata=//" )
  if [ $? -ne 0 -o "X$metadataPathArg" = "X" ]; then
	$ECHO "$ECHO $gppidArgs | $CUT -f3 -d\ " >> $LOCAL_LOG_FILE 
	$ECHO "output=\"$internal_failure_msg\""
	exit 0
  fi
  jsonDirPath=$(dirname "$metadataPathArg" )
  if [ $? -ne 0 -o "X$jsonDirPath" = "X" ]; then
	$ECHO "dirname $metadataPathArg" >> $LOCAL_LOG_FILE  
	$ECHO "output=\"$internal_failure_msg\""
	exit 0
  fi

  #run DDR to determine whether we are using ngm upgrade or old upgrade
  /opt/DDR/bin/DDRService --action=collect_and_verify --path_to_metadata=${jsonDirPath}/conditions_set_is_ngm_upgrade.json --output_file=/tmp/DDR_validation_$$ 2>/dev/null
  is_ngm_upgrade=$?

  output=""

  if  [ $is_ngm_upgrade -ne 0 ]; then
    open_sessions=$(psql_client cpm postgres -t -c "select distinct username from worksession where showinopenworksessionslist='t' and numberofoperations>0 and username in (select name from userbase_data where (dtype='Admin' or (dtype='CPApplicationUser' and name='WEB_API')) and not deleted and dlesession=0) order by username;" 2>/dev/null)
    open_sessions="$(echo -e "${open_sessions}" | sed -e 's/^[[:space:]]*//')"
  
    # Checking if there are open work sessions.
  
    if [ -z "$SKIP_OPEN_SESSIONS_VERIFICATION"  -a ! -z "$open_sessions" ]; then
	  output="Operation failed. Publish or Discard all sessions and run operation again. Administrators with open sessions: $open_sessions . " 
    fi
  fi
  
  global_data_centers=$(psql_client cpm postgres -t -c "select name from cms_data where domainid='1e294ce0-367a-11e3-aa6e-0800200c9a66' and dlesession>-1 and deleted='f' ;" 2>/dev/null)
  if [ ! -z "$global_data_centers" ]; then
	  output="${output}${output:+\n} Operation failed. The target version does not support global 'Data Center' objects, Please remove the following objects and run operation again. Global Data Centers: $global_data_centers" 
  fi
  
  if [[ "X$ver" == "XR80" ]]; then
		docsec_icons_objects=$($PSQL_CLIENT cpm postgres -t -c "select name from dleobjectderef_data where name ilike 'ep_docSec%';")
		docsec_icons_objects="$($ECHO -e "${docsec_icons_objects}" | $SED -e 's/^[[:space:]]*//')"
		if [ ! -z "$docsec_icons_objects" ] 
			then
				output="${output}${output:+\n} Operation failed. Redundant Document Security icons objects were found. Please contact Check Point support and mention sk149012."
			fi
  fi

if [ $is_ngm_upgrade -ne 0 ]; then
  trustedCasExists=$(psql_client cpm postgres -t -c "select exists (select 1 from information_schema.tables where table_name='trustedca_data');" 2>/dev/null | sed -e 's/^[[:space:]]*//')
  if [[ "$trustedCasExists" == "t" ]]; then
		output="${output}${output:+\n}Operation failed. The target version does not support Dedicated Log Server."
  fi
fi
	
#get cpm_status:
	$ECHO "Checking cpm status to decide if we should stop postgres" >> /opt/DDR/collect_mgmtready_output
	$MDS_FWDIR/scripts/cpm_status.sh no_print
	let cpm_status=$?   
	$ECHO "CPM status is: $cpm_status">> /opt/DDR/collect_mgmtready_output

# stop postgres
   if [ $POSTGRES_WAS_DOWN -eq 1 ];then
    if [ -f /etc/.wizard_accepted ]; then
	  if [ $cpm_status -eq $CPM_NOT_RUNNING ] || [ $cpm_status -eq $CPM_FAILED_START ]; then
        $ECHO "==================================================$MDS_FWDIR/scripts/postgres_stop.sh" >> /opt/DDR/collect_mgmtready_output 2>&1
        $MDS_FWDIR/scripts/postgres_stop.sh  >> /opt/DDR/collect_mgmtready_output 2>&1
	  fi
	fi	
  fi
fi


  if [ "$output" == "" ]
  then
          $ECHO "success"
  else
          $ECHO $output
  fi


exit 0