#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

# THIS SCRIPT IS FOR R80.X ONLY !!
# FOR OTHER VERSIONS  TEST / MODIFY THE SCRIPT


CPPROD_UTIL=$CPDIR/bin/cpprod_util
SU="/bin/su" 
PWD="/bin/pwd"
MAX_TRIES=60
SLEEP="/bin/sleep"
CAT="/bin/cat"
ECHO="/bin/echo"
CHMOD="/bin/chmod"
vsec_nested_group_output="/opt/DDR/collect_vsec_nested_group_output"
# exit codes of cpm_status.sh
CPM_NOT_RUNNING=13
CPM_FAILED_START=14

check_postgres_status()
{
	local RET=1
	local RETURN_VAL=$1
	cd $PGDIR
	$ECHO "==================================================$FWDIR/scripts/postgres_commands.sh status" >> $vsec_nested_group_output 2>&1
	$SU -s /bin/bash -c "$FWDIR/scripts/postgres_commands.sh status" cp_postgres >> $vsec_nested_group_output 2>&1
	RET=$?
	eval $RETURN_VAL="'$RET'"
}

busy_wait_check_postgres_status()
{
	local RETURN_VAL=$1
	cd $PGDIR
	TRIES=0
	local POSTGRES_STATUS_RET=1
	local QUERY_RET=1
	if [ -f /var/tmp/postgres_max_tries ];then
		MAX_TRIES=`$CAT /var/tmp/postgres_max_tries`
	fi
	while [ $POSTGRES_STATUS_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
	do
		check_postgres_status POSTGRES_STATUS_RET
		$SLEEP 1
		let TRIES=TRIES+1
	done
	TRIES=0
	if [ $POSTGRES_STATUS_RET -eq 0 ];then
		TRIES=0
		while [ $QUERY_RET -ne 0 -a $TRIES -lt $MAX_TRIES ]
		do
			$ECHO "==================================================$FWDIR/bin/psql_client -U postgres cpm -c select 1" >> $vsec_nested_group_output 2>&1
			$FWDIR/bin/psql_client -U postgres cpm -c "select 1;" >> $vsec_nested_group_output 2>&1
			QUERY_RET=$?
			$SLEEP 1
			let TRIES=TRIES+1
		done
	else
		# create resolve script
		$ECHO "#!/bin/bash" > /opt/DDR/resolve_permissions
		$ECHO "$CHMOD 755 $FWDIR/..; $CHMOD 755 $FWDIR/; $CHMOD 755 $FWDIR/scripts/; $CHMOD 755 $FWDIR/scripts/postgres_commands.sh;  $CHMOD 755 $CPDIR/lib; $CHMOD 755 $CPDIR/lib/libcrypto.so.1.0.0; exit 0;" >> /opt/DDR/resolve_permissions
		$CHMOD 777 /opt/DDR/resolve_permissions
		# print message to user
		$ECHO "Could not run compatibility check - run '/opt/DDR/resolve_permissions' and try again." >> $vsec_nested_group_output 2>&1
	fi		
	eval $RETURN_VAL="'$QUERY_RET'"
}

isManagement=`$CPPROD_UTIL CPPROD_GetValue FW1 FWManagement 4`
isLogServer=`$CPPROD_UTIL CPPROD_GetValue FW1 LogServer 4`
STATUS=0

# if our version is prior to R80 then this script is not relevant , return success
isVersionOlderThan "R80"
if [ $? == 0 ]; then
	$ECHO "success"
	exit 0
fi


if [ "$isManagement" == "1" -o "$isLogServer" == "1" ]; then

  # start postgres
  if [ "X$MDSDIR" != "X" ]; then
      FWDIR=$MDS_TEMPLATE
  fi
  POSTGRES_WAS_DOWN=0
  POSTGRES_STATUS=3
  
  WORK_DIR=`$PWD`
  check_postgres_status POSTGRES_STATUS
  cd $WORK_DIR
  if [ $POSTGRES_STATUS -ne 0 ]; then
	POSTGRES_WAS_DOWN=1
  fi
  if [ $POSTGRES_WAS_DOWN -eq 1 ];then
	  $ECHO "==================================================$FWDIR/scripts/postgres_start.sh" >> $vsec_nested_group_output 2>&1
	  $FWDIR/scripts/postgres_start.sh  >> $vsec_nested_group_output 2>&1
	  POSTGRES_STATUS=3
	  busy_wait_check_postgres_status POSTGRES_STATUS
	  cd $WORK_DIR
	  if [ $POSTGRES_STATUS -ne 0 ]; then
		  $ECHO "failed to start postgres. See $vsec_nested_group_output for more information."
		  exit 0
	  fi
  fi


  #check if there are network groups that contains nested groups which contains data center objects
  network_groups_with_nested_cloud_groups=$(psql_client cpm postgres -t -c "SELECT DISTINCT main_dod.name FROM dleobjectderef_data main_dod JOIN link_data main_l ON main_dod.objid=main_l.sourceobjectid JOIN dleobjectderef_data inner_dod ON main_l.destinationobjectid=inner_dod.objid JOIN link_data inner_l ON inner_dod.objid=inner_l.sourceobjectid JOIN cloudshadowobject_data cso ON inner_l.destinationobjectid=cso.objid WHERE main_dod.objclass = 'com.checkpoint.objects.classes.dummy.CpmiNetworkObjectGroup' AND inner_dod.objclass = 'com.checkpoint.objects.classes.dummy.CpmiNetworkObjectGroup' AND main_dod.deleted='f' AND main_dod.dlesession=0 AND inner_dod.deleted='f' AND inner_dod.dlesession=0 AND main_l.deleted='f' AND main_l.dlesession=0 AND inner_l.deleted='f' AND inner_l.dlesession=0 AND cso.deleted='f' AND cso.dlesession=0;" 2>/dev/null)
  if [ ! -z "$network_groups_with_nested_cloud_groups" ]; then
  	  output="$network_groups_with_nested_cloud_groups"
  	  $ECHO "output = $output" >> $vsec_nested_group_output
  fi

#get cpm_status:
	$ECHO "Checking cpm status to decide if we should stop postgres" >> /opt/DDR/collect_mgmtready_output
	$MDS_FWDIR/scripts/cpm_status.sh no_print
	let cpm_status=$?   
	$ECHO "CPM status is: $cpm_status">> /opt/DDR/collect_mgmtready_output

# stop postgres
   if [ $POSTGRES_WAS_DOWN -eq 1 ];then
    if [ -f /etc/.wizard_accepted ]; then
	if [ $cpm_status -eq $CPM_NOT_RUNNING ] || [ $cpm_status -eq $CPM_FAILED_START ]; then
        $ECHO "==================================================$MDS_FWDIR/scripts/postgres_stop.sh" >> $vsec_nested_group_output 2>&1
        $MDS_FWDIR/scripts/postgres_stop.sh  >> $vsec_nested_group_output 2>&1
	  fi
	fi	
  fi
fi


  if [ "X$output" == "X" ]
  then
          $ECHO "success"
  else
          $ECHO $output
  fi


exit 0
