#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

#Script collects NSX-T deployment type of the machine. If machine is not in NSXT_EW_GW, DeploymentType will be an empty string.
ECHO=/bin/echo
XMLLINT=/bin/xmllint
GREP=/bin/grep
CUT=/bin/cut
SED=/bin/sed
rootCloudFilesPath=/tmp

#possible deploymentType File
cloudFile="OVF.xml"

DeploymentType=""


#fetch deploymenttype # string example: <Property oe:key="nsx.deploymenttype" oe:value="nsx_eastwest_native"/>

if [ -f ${rootCloudFilesPath}/$cloudFile ]
then
	DeploymentType=`$ECHO -e "setrootns\ncat oe:Environment/oe:PropertySection/oe:Property/@oe:key|oe:Environment/oe:PropertySection/oe:Property/@oe:value\n" | $XMLLINT --shell /tmp/OVF.xml | $GREP -e "key" -e "value"  | $CUT -d= -f2- | $SED -e 's/\n//g' | $SED -e 'N;s/\n/=/'  | $SED -e 's/\&amp;/\&/g' | $SED -e "s/\&quot;//g" | $ECHO eval "nsx.deploymenttype"="nsx_eastwest_native" | $CUT -d'=' -f2-`
fi

$ECHO "DeploymentType='$DeploymentType'"

exit 0