#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

ECHO=/bin/echo
OUTPUT="is_SP=\"0\""
INDICATION_FILE="/tmp/disable_weights_fix"
indication_file_exist=0
sgm1_missing=0


if [[ -f /usr/bin/is_scalable_platform.sh ]]; then
	sg_list=`/usr/lib/smo/libsgdb.tcl sgdb_get_my_sg_id val`
	if [ $? -eq 0 ] && [ "$sg_list" != "NA" ]; then 
		for sg_id in ${sg_list}; do
			sites_list=`/usr/lib/smo/libsgdb.tcl sgdb_get_chassis_list $sg_id val`
			if [ $? -ne 0 ] || [ "$sites_list" = "NA" ]; then 
				continue
			fi
			for site_id in ${sites_list}; do
				members_list=`/usr/lib/smo/libsgdb.tcl sgdb_get_sgm_list $sg_id $site_id val`
				if [ $? -ne 0 ] || [ "$members_list" = "NA" ]; then 
					continue
				fi
				members_arr=($members_list)
				members_count=${#members_arr[@]}
				sgm_1_count=`echo $members_list | grep "1" |  grep -v '[0-9][0-9]' | wc -l`
				if [ "$sgm_1_count" = "0" ] && [ $members_count -gt 1 ]; then
					sgm1_missing=1
				fi
			done
		done
		if [[ -f $INDICATION_FILE ]]; then
			indication_file_exist=1
		fi
		OUTPUT="is_SP=\"1\" sgm1_missing=\"$sgm1_missing\" indication_file_exist=\"$indication_file_exist\""
	fi
fi

$ECHO $OUTPUT

exit 0
