#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

ECHO=/bin/echo

# Script which collect data on Skyline processes
parseArgs "$@"

function check_cpview_api_service_is_running() {
	CPVIEW_API_SERVICE_PID=$(cpwd_admin getpid -name CVIEWAPIS 2>/dev/null | tr -d "[[:space:]]")
	if [[ "X${CPVIEW_API_SERVICE_PID}" != "X0" ]] && [[ "X${CPVIEW_API_SERVICE_PID}" != "X" ]]; then 
		true
	else
		false
	fi
}

function check_cpview_api_service_has_ran() {
	if [[ -f $CPDIR/conf/cpview_api_service.version ]]; then 
		true
	else
		false
	fi
}

function check_otelcol_is_running() {
	if [[ -f /opt/CPotelcol/CPotelcolCli.sh ]]; then 
		/opt/CPotelcol/CPotelcolCli.sh is_running >/dev/null 2>&1
		if [[ $? -eq 1 ]]; then 
			true
		else 
			false
		fi
	else
		false
	fi
}

function check_otelcol_has_ran() {
	timeout 10s dbget otlp:otelcol:active >/dev/null 2>&1
	if [[ $? -eq 0 ]]; then 
		true
	else 
		false
	fi
}

function check_cpview_exporter_is_running() {
	if [[ -f /opt/CPviewExporter/CPviewExporterCli.sh ]]; then 
		/opt/CPviewExporter/CPviewExporterCli.sh is_running >/dev/null 2>&1
		if [[ $? -eq 1 ]]; then 
			true
		else 
			false
		fi
	else
		false
	fi
}

function check_cpview_exporter_has_ran() {
	timeout 10s dbget otlp:cpviewexporter:active >/dev/null 2>&1
	if [[ $? -eq 0 ]]; then
		true
	else 
		false
	fi
}

check_cpview_api_service_is_running_value="1"

if ! check_cpview_api_service_is_running; then 
	check_cpview_api_service_is_running_value="0"
fi


check_cpview_api_service_has_ran_value="1"

if ! check_cpview_api_service_has_ran; then 
	check_cpview_api_service_has_ran_value="0"
fi

check_otelcol_is_running_value="1"

if ! check_otelcol_is_running; then 
	check_otelcol_is_running_value="0"
fi


check_otelcol_has_ran_value="1"

if ! check_otelcol_has_ran; then 
	check_otelcol_has_ran_value="0"
fi

check_cpview_exporter_is_running_value="1"

if ! check_cpview_exporter_is_running; then 
	check_cpview_exporter_is_running_value="0"
fi


check_cpview_exporter_has_ran_value="1"

if ! check_cpview_exporter_has_ran; then 
	check_cpview_exporter_has_ran_value="0"
fi

cpview_api_service_status=0

if [ "X$check_cpview_api_service_is_running_value" = "X1" ] || [ "X$check_cpview_api_service_has_ran_value" = "X1" ]; then 
	cpview_api_service_status=1
fi

otelcol_status=0

if [ "X$check_otelcol_is_running_value" = "X1" ] || [ "X$check_otelcol_has_ran_value" = "X1" ]; then 
	otelcol_status=1
fi

cpview_exporter_status=0

if [ "X$check_cpview_exporter_is_running_value" = "X1" ] || [ "X$check_cpview_exporter_has_ran_value" = "X1" ]; then
    cpview_exporter_status=1
fi

skyline_is_running=0

if [ $cpview_api_service_status -eq 1 ] && [ $otelcol_status -eq 1 ] && [ $cpview_exporter_status -eq 1 ]; then 
	skyline_is_running=1
fi



$ECHO "skyline_is_running=\"$skyline_is_running\""

exit 0