#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

ECHO=/bin/echo
GREP=/bin/grep
CPHAPROB=$FWDIR/bin/cphaprob
PATTERN="Cluster Mode"

#check if the cloud platform is AWS
cat /etc/in-aws >/dev/null
if [ $? != 0 ] ; then
	$ECHO "Not AWS environment"
else	
	#Check if the machine is active cluster member
	IS_CLUSTER_MEMBER=`$CPHAPROB stat 2>/dev/null`
	if [ $? != 0 ] ; then
		$ECHO "Not a cluster member"	
	else
		if [[ "$IS_CLUSTER_MEMBER" == *"HA module not started."* ]] ; then
			$ECHO "Not a cluster member"
		elif [[ "$IS_CLUSTER_MEMBER" == *$PATTERN* ]] ; then
			CLUSTER_MODE=`$ECHO "$IS_CLUSTER_MEMBER" | $GREP "$PATTERN"` #take the "Cluster Mode" line
			if [[ "$CLUSTER_MODE" == *"Active Active"* ]]; then #search for Active Active
				$ECHO "Active Active cluster"
			else
				$ECHO "Not an Active Active cluster"
			fi
		else
			$ECHO "Not an Active Active cluster"
		fi
	fi	
fi

exit 0