#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

#script collects the machine role

CPPROD_UTIL=$CPDIR/bin/cpprod_util

#possible machine roles, first spelling option for every role will be used to appear to the user!!
MDS="Multi-Domain Server,MDS,mds,provider-1,Provider-1,Provider1,provider1"
GW="Security Gateway,Gateway,gateway,gw,GW,GATEWAY,GateWay"
MGMT="Security Management Server,management,mgmt,MGMT,Management,MANAGEMENT"
SA="StandAlone,standAlone,sa,SA,standalone,STANDALONE,STAND_ALONE,stand_alone,Stand_Alone,Stand_alone,stand_Alone,stand alone,Stand Alone,Stand alone"
VSX="VSX,vsx,Security Gateway,Gateway,gateway,gw,GW,GATEWAY,GateWay"
LOGSERVER="LogServer,logserver,LOGSERVER,logServer,Logserver,log server,Log Server,LOG SERVER,log_server,Log_Server,LOG_SERVER"
MGMT_HA=""
SECONDARY_MGMT=""
MHO="MHO"

#set the current machine role to an empty string.
#if no machine role is found end script with appropriate error
machineRole=""

#find the current machine role
function findMachineRole()
{
	#check if machine is MDS
	if [ "$MDSDIR" != "" ]
	then
			machineRole="$MDS"
			return
	fi

	isLogServer=`$CPPROD_UTIL CPPROD_GetValue FW1 LogServer 4`
	if [ "X$isLogServer" == "X1" ]
	then
		machineRole="$LOGSERVER"
		return
	fi
	
	isVSX=`$CPPROD_UTIL FwIsVSX 2>/dev/null`
	if [ X$isVSX == "X1" ]
	then
		machineRole="$VSX"
		return
	fi
	
	is_mgmt_type=`$CPPROD_UTIL FwIsFirewallMgmt`
	is_gw_type=`$CPPROD_UTIL FwIsFirewallModule`
	if [ X$is_mgmt_type = "X1" ]
	then
		if [ X$is_gw_type = "X1" ]
		then
			machineRole="$SA"
			return
		fi
		machineRole="$MGMT"
		return
	elif [ X$is_gw_type = "X1" ]
	then
		machineRole="$GW"
		return
	fi
	
	SecurePlatformSeries=`$CPPROD_UTIL CPPROD_GetValue SecurePlatform Series 0`
	if [ "$SecurePlatformSeries" = "Maestro Orchestrator" ]; 
	then
		machineRole="$MHO"
		return
	fi
}

findMachineRole

if [ "X$machineRole" = "X" ]
then
	machineRole="could_not_be_collected";
fi

$ECHO "machineRole='$machineRole'"

exit 0
