#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

VERIFY_APPLIANCE_TYPE=/opt/DDR/Definitions/DDR_Scripts/Verify_ApplianceType.sh
VERIFY_KERNEL_VERSION=/opt/DDR/Definitions/DDR_Scripts/Verify_KernelVersion.sh
VERIFY_FILE_EXISTS=/opt/DDR/Definitions/DDR_Scripts/Verify_FileExists.sh
ECHO=/bin/echo

rv=1

#parameters received are 'file_name', 'file_found', 'series', 'appliance_name', 'machine_appliance_name', 'machine_series', 'min_version', 'max_version', and 'curKernelVersion'
parseArgs "$@"

appliance_type="`$VERIFY_APPLIANCE_TYPE series=$series appliance_name=$appliance_name machine_appliance_name=$machine_appliance_name machine_series=$machine_series`"
appliance_type_rv=$?


kernel_version_="`$VERIFY_KERNEL_VERSION min_version=$min_version max_version=$max_version curKernelVersion=$curKernelVersion`"
kernel_version_rv=$?

file_exists_="`$VERIFY_FILE_EXISTS file_name=$file_name file_found=$file_found`"
file_exists_rv=$?


if [ "X$appliance_type_rv" = "X1" ] || [ "X$kernel_version_rv" = "X1" ] || [ "X$file_exists_rv" = "X0" ]
then
        rv=0
fi

endCheck $rv "To upgrade an Open Server with kernel 2.6.18 to R80.40, see sk164138."
