#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

#script verifies that the total hard disk size is between 'min' and 'max'
#parameters received:
# 1) 'min', minimum allowed hard disk size, in GB
# 2) 'max', maximum allowed hard disk size, in GB
# 3) 'disk_size', the total hard disk size received from collect, in GB

BC=/usr/bin/bc
ECHO=/bin/echo

rv=0
internal_err_str="Internal error: "

#parameters received are 'min', 'max' and 'disk_size'
parseArgs "$@"

#-------------------------
#MAIN
#-------------------------

if [ "X$min" = "X" ] && [ "X$max" = "X" ]
then
	endCheck 2 "$internal_err_str 'min' and 'max' in conditions_set.json are both empty"
fi

if [ ! -z $min ]
then
	if (( $($ECHO "$disk_size" '<' "$min" | $BC -l) )) 
	then
			rv=1
	fi
fi

if [ ! -z $max ]
then
	if (( $($ECHO "$disk_size" '>' "$max" | $BC -l) )) 
	then
			rv=1
	fi
fi

endCheck $rv "Total hard disk size is ${disk_size}GB"