#!/bin/bash
. `dirname $0`"/DDR_shared_functions"



#script verifies image build number for cloud machune 
#parameters received:
# 1) 'max_build', user defined max image build build in conitions set
# 2) 'min_build' user defined min image build in conitions set
# 3) 'image_build_number' received from collect - corrent build number on the machune
rv=0
#parameters received are 'max_build', 'min_build' and parameters from collect are 'image_build_number' 
parseArgs "$@"

error_verifying="Could not verify image build number"

RESULT="Image build number is $image_build_number"

if [ "X$image_build_number" = "X0" ]
then
	rv=1
	RESULT="image build number was not found -verify that you are using cloud machine"
else   
# verify max_build
if [ "X$max_build" != "X" ]
	then 
		#check max_build is only digits
		verifyOnlyDigits $max_build "$error_verifying"		
		if [ $image_build_number -gt $max_build ]
		then
			rv=1
		fi
	fi
fi
#check min_build
if [ "X$min_build" != "X" ] 
then 
	#check min_build is only digits
	verifyOnlyDigits $min_build "$error_verifying"		
	if [ $image_build_number -lt $min_build ]
	then
		rv=1
	fi
fi


endCheck $rv "$RESULT"