#!/bin/bash
. `dirname $0`"/DDR_shared_functions"

#script verifies machine role
#parameters received:
# 1) 'roles', user defined list seperated by commas in conditions set of permitted machine roles
# 2) 'machineRole' received from collect


CPPROD_UTIL=$CPDIR/bin/cpprod_util
AWK=/bin/awk

#return value default value is 0
rv=0
#possible machine roles, first spelling option for every role will be used to appear to the user!!
MDS="Multi-Domain Server,MDS,mds,provider-1,Provider-1,Provider1,provider1"
GW="Security Gateway,Gateway,gateway,gw,GW,GATEWAY,GateWay"
MGMT="Security Management Server,management,mgmt,MGMT,Management,MANAGEMENT"
SA="StandAlone,standAlone,sa,SA,standalone,STANDALONE,STAND_ALONE,stand_alone,Stand_Alone,Stand_alone,stand_Alone,stand alone,Stand Alone,Stand alone"
VSX="VSX,vsx"
LOGSERVER="LogServer,logserver,LOGSERVER,logServer,Logserver,log server,Log Server,LOG SERVER,log_server,Log_Server,LOG_SERVER"
MGMT_HA=""
SECONDARY_MGMT=""
MHO="MHO"
MLM="mlm,MLM"



#parameters received are 'roles' - the permitted machine roles - and 'machineRole'
parseArgs "$@"

if [ "X$machineRole" = "Xcould_not_be_collected" ]
then
	endCheck 1 "Could not collect machine's role"
fi


roleString=`$ECHO $machineRole | cut -d , -f 1`

#check if machine role matches one of the roles in the list
IFS=','
found_role=0
for role in $roles
do
	for role_spelling in $machineRole
	do
		if [ "X$role" = "X$role_spelling" ]
		then
			found_role=1
			break
		fi
	done
done

if [ $found_role -ne 1 ]
then
	rv=1
fi

endCheck $rv "Machine's configuration is '`$ECHO $roleString`'"
