#!/bin/sh

MV=/bin/mv
RM=/bin/rm
CAT=/bin/cat
GREP=/bin/grep
AWK=/bin/awk
WC=/usr/bin/wc
PS=/bin/ps
SED=/bin/sed
TELLPM=/bin/tellpm
CHMOD=/bin/chmod
ECHO=/bin/echo
LN=/bin/ln
RPM=/bin/rpm
MKDIR=/bin/mkdir
DBSET=/bin/dbset
DBGET=/bin/dbget
DASTOP=/opt/CPda/bin/dastop
CPVINFO=$CPDIR/bin/cpvinfo
LOG_FILE=/opt/CPda/bin/hook_upg.log
SLEEP=/bin/sleep

NAVTREE=/web/xml2/navtree.xml
OVERVIEW=/web/htdocs2/js/overview.js

$CAT $NAVTREE | $GREP "<name>software-updates-group-new</name>" 1>/dev/null 2>&1
if [ $? -eq 0 ]
then
	# Remove software updates group from navtree.xml
	$SED -i '/.*DA New GUI Start.*/,/.*DA New GUI End.*/d' $NAVTREE
fi

$CAT $NAVTREE | $GREP "<name>software-updates-group</name>" 1>/dev/null 2>&1
if [ $? -ne 0 ]
then
	# software updates group not found in navtree.xml - insert software updates into it
	$SED -i '/<\/application>/ i\
      <!-- PING Start -->\
      <features>\
        <name>software-updates-group</name>\
        <feature>\
          <name>installer</name>\
        </feature>\
        <feature>\
          <name>installer_conf</name>\
        </feature>\
      </features>\
      <!-- PING End -->' $NAVTREE
fi

#update the link in overview.js
$CAT $OVERVIEW | $GREP "tree/available_updates" 1>/dev/null 2>&1
if [ $? -eq 0 ]
then
  # replace the link
  $SED -i 's/tree\/available_updates/tree\/installer/' $OVERVIEW
fi

$ECHO "end of MoveToOldGUI.sh"
