#!/bin/sh

if [ $1 ]; then
	echo "Got Param $1"
else
	exit
fi
newpartition=$1
if [ -r $newpartition ]; then
	echo $newpartition "Found"
	dd if=/dev/urandom of=$newpartition/dev/urandom bs=1M count=10
	cp /etc/hosts $newpartition/etc/hosts
	cp /etc/passwd $newpartition/etc/passwd
	cp /etc/group $newpartition/etc/group
	cp /etc/shadow $newpartition/etc/shadow
	cp /etc/gshadow $newpartition/etc/gshadow

	CP_POSTGRES_UID=1008
	CP_POSTGRES_USERNAME="cp_postgres"
	CP_POSTGRES_HOMEDIR="/home/cp_postgres"
	CP_POSTGRES_SHELL="/bin/sh"
	CP_POSTGRES_GID=0
	CP_POSTGRES_REALNAME="Postgres"
	CP_POSTG_GID=1008
	CP_POSTG_GROUPNAME="cppostg"

	# Creating user cp_postgres and group cppostg with default values in the new partition
	chroot $newpartition /bin/bash --verbose  -c "userdel $CP_POSTGRES_USERNAME ; useradd -u $CP_POSTGRES_UID -g $CP_POSTGRES_GID -d $CP_POSTGRES_HOMEDIR -s $CP_POSTGRES_SHELL -c $CP_POSTGRES_REALNAME -p \"*\" $CP_POSTGRES_USERNAME"
	chroot $newpartition /bin/bash --verbose  -c "groupdel $CP_POSTG_GROUPNAME ; groupadd -g $CP_POSTG_GID $CP_POSTG_GROUPNAME"

else
	echo $newpartition "Not Found"
fi

echo "end of create_postgres_user.sh"
