
CP.InstalledUpdates = {
    // Defaults
	MAIN_PANEL_ID: 'installed_updates_panel',
	legacy_display_status: true,
	SUBMIT_URL: '/cgi-bin/installer.tcl',
	MACHINE_VERSION: 'N/A',
	OS_BUILD: 0,
	is_mds: false

    ,getIsMds: function() { 
        Ext.Ajax.request({
            url: "/cgi-bin/upgrade.tcl",
            method: "GET",
            params: {
                action: 'get_upload_path'
            },
            success: function(jsonResult) {
                var jsonData = Ext.decode(jsonResult.responseText);

                if (jsonData.data && jsonData.data.is_mds) {
                    CP.InstalledUpdates.is_mds = jsonData.data.is_mds;
                }
            },
            failure: function() {
                if (CP.InstalledUpdates.isInPage==true) {
                    setTimeout("CP.InstalledUpdates.getIsMds();", 1000); // polling
                }
            }
        });
    }

    ,getDisplayLegacyStatus: function() { 
        Ext.Ajax.request({
            url: "/cgi-bin/installer_policy.tcl",
            method: "GET",
            success: function(jsonResult) {
                var jsonData = Ext.decode(jsonResult.responseText);
                if (jsonData.data && jsonData.data.legacy_display) {
                    if (jsonData.data.legacy_display == "true"){
                        CP.InstalledUpdates.legacy_display_status = true;
                    }
                    else {
                        CP.InstalledUpdates.legacy_display_status = false;
                    }

                }
            },
            failure: function() {
                setTimeout("CP.InstalledUpdates.getDisplayLegacyStatus();", 1000); // polling
            }
        });
    }

    ,getMachineDetails: function() { 
        Ext.Ajax.request({
            url: CP.InstalledUpdates.SUBMIT_URL,
            method: "GET",
            params: {
                get_machine_details: 1
            },
            success: function(jsonResult) {
                var jsonData = Ext.decode(jsonResult.responseText);
                if (jsonData)
                {
                    if (jsonData.cur_version != "")
                        CP.InstalledUpdates.MACHINE_VERSION = jsonData.cur_version;
                    if (jsonData.os_build != "")
                        CP.InstalledUpdates.OS_BUILD = jsonData.os_build;
                }
            },
            failure: function() {
                setTimeout("CP.InstalledUpdates.getMachineDetails();", 1000); // polling
            }
        });
    }

    // init: builds the page
    ,init:function() {
		var page_items=CP.InstalledUpdates.getPageIframe();

        var page = {
            title: "Installed Updates",
            panel: Ext.create('CP.WebUI4.DataFormPanel', {
                id: CP.InstalledUpdates.MAIN_PANEL_ID,
                margin: '0 !important',
                autoHeight: 'true !important',
				height: '100%',
                items: [ page_items ]
            })
        }

        CP.InstalledUpdates.isInPage=true;
        CP.InstalledUpdates.getIsMds();

        CP.InstalledUpdates.getDisplayLegacyStatus();
        CP.InstalledUpdates.getMachineDetails();
		
		// Create empty popup because we need that modal mask will be created
		CP.InstalledUpdates.emptyPopUp();

        //show the page
        CP.UI.updateDataPanel( page );
    }
	
	// Create an empty popup because we need that modal mask will be created
	,emptyPopUp: function() {
		
		 var modalWin = Ext.create('CP.WebUI4.ModalWin', {
            id: 'init-modal-window',
            name: 'init-modal-window',
            width: 0,
            height: 0,
            items: []
		 });
		
        modalWin.show();
		modalWin.hide();
	}
	
	,getPageIframe: function() {
		var iframe = Ext.create('Ext.form.FieldSet', {
			labelWidth: 1,
			style: 'border: 0; height: 100%; padding: 0 !important;',
			height: '100%',
			padding: '0 !important',
			layout: 'anchor', 
			items: [{
				xtype: 'box',
				autoEl: {
					tag: 'iframe',
					src: '../CPda/React/index.html?page=installed-updates',
					style: 'border: 0; height: 100%; z-index: 19008; position: absolute;',
					width: '100%',
					height: '100%',
					padding: '0 !important',
				}
			  }
			]
		});
		
		return [ iframe ]
	}
	
	,AF_rend: function(available_from_str, metadata, record, rowIndex) {
        // the expected format of the string is: "yyyy-mm-dd hh:mm:ss"
        var date;
        var date_str;
        var date_split;
        var time='';
        var time_str;
        var time_ending='';
        if (available_from_str=="")
            return "";
        var new_str=available_from_str.replace("  "," ");
        date_split = new_str.split(" ");
        date = date_split[0].split("-"); //  1 - month   2 - day  0 - year
        time = date_split[1].split(":");
        date_str=CP.util.dateToStr(date[2],date[1],date[0]);
        time_str=CP.util.timeToStr(time[0],time[1],time[2]);

        return date_str;//+" "+time_str;
    }
	
	,DateToString: function(date) {
        // the expected format of the string is: "Sun Jan  2 16:36:15 2022"
		var date_split;
		var month = '';
		var day = '';
		var year = '';
        if (date=="")
            return "";
        var new_str=date.replace("  "," ");
        date_split = new_str.split(" ");
		month = date_split[1]; 
		day = date_split[2]; 
        year = date_split[4]; 

        return day + " " + month + " " + year;
    }
	
	,getFileSize: function(size) {
		var fileSize = Ext.util.Format.fileSize(size)
		
		return fileSize;
	}
	
	,supressFailLockMsg: function() {
        CP.global.supress_update_msg=1;
    }

    ,supressUnableToConnectMsg: function() {
        CP.global.isRebooting = true;
    }

    ,overrideLock: function() {
        if (CP.global.token == -1) {
            CP.global.token = 0;
            CP.util.configLock_req("override");
        }
    }
	
	,doDownload: function( filename ){
        location.href =  _sstr+"/cgi-bin/img_export.tcl?file="+filename;
        for (var i=0; i<CP.Packages.store.getCount(); i++) {
            if ((CP.Packages.store.getAt(i) == undefined) || (CP.Packages.store.getAt(i).data == undefined))
                continue;
            var new_package_name_table = CP.Packages.store.getAt(i).data.package_name.replace(/\.[^/.]+$/, ""); // removing the file extension
            var new_filename=filename.replace(/\.[^/.]+$/, ""); // removing the file extension
            if (new_filename==new_package_name_table) {
                // found the package in the table - remove the local status text
                CP.Packages.store.getAt(i).data.local_status_text="";
            }
        }
    }
}