#!/usr/bin/cgisu -r

# Copyright Check Point

source subs.tcl
source debug.tcl
source showResult.tcl
source json.tcl

namespace eval ::installer_mail {
    variable debug 1
    global dFile
    set dFile "/tmp/installer_mail.post.debug"

    variable err_list [list]
    variable set_list [list]
    set result 0
    global myDb
    global method
	
	set bind_ping "installer"
	set trigger_file "/opt/CPda/bin/DAClient"

    if {$debug} {
        set fd [open $dFile w]
        puts $fd "Debug started"
        close $fd
    }

    if {[catch {libdb init -local} myDb]} {
        #failed to initialize!!!
		ipso -nohtml
		MIME text
        errorOut "Unable to connect to database ${myDb}"
    }
	
    ipso -nohtml
    set method [get_Method]
    MIME text
    printDebug

    global Q_Names
	if {$method == "POST"} {
		variable delete 0
		foreach var $Q_Names {
			set val [getVal $var]
			if {$var == "delete_user"} {
				set delete 1
			}
			if {$var == "address"} {
				set address $val
			}
			if {$var == "available"} {
				set available $val
			}
			if {$var == "d_status"} {
				set d_status $val
			}
			if {$var == "i_status"} {
				set i_status $val
			}
		}
		if {$delete == 1} {
			libdb set $myDb "${bind_ping}:mail_notifications:${address}" ""
		}
		if {$delete == 0} {
			libdb set $myDb "${bind_ping}:mail_notifications:${address}" 1
			libdb set $myDb "${bind_ping}:mail_notifications:${address}:available" "${available}"
			libdb set $myDb "${bind_ping}:mail_notifications:${address}:d_status" "${d_status}"
			libdb set $myDb "${bind_ping}:mail_notifications:${address}:i_status" "${i_status}"
			# activate the mail notifications update flag
		}
		
		#libdb set $myDb "${bind_ping}:mail_notifications_update" 1
		set response [exec $trigger_file update_mail_notifications]
		
		libdb set $myDb ":save" ""
		
		HTML $response
	}
	if {$method == "GET"} {

		set mailList [list]
		foreach address [libdb iterate children $myDb ${bind_ping}:mail_notifications] {
			if {[libdb get $myDb ${bind_ping}:mail_notifications:${address}] == ""} {
				continue ; # doesn't really exist; skip
			}
			set mailDict [dict create]
			dict set mailDict address $address
			dict set mailDict available [libdb get $myDb ${bind_ping}:mail_notifications:${address}:available]
			dict set mailDict d_status [libdb get $myDb ${bind_ping}:mail_notifications:${address}:d_status]
			dict set mailDict i_status [libdb get $myDb ${bind_ping}:mail_notifications:${address}:i_status]
			lappend mailList $mailDict
		}
		set maildata [dict create]
		dict set maildata mailhub [libdb get $myDb "ssmtp:mailhub"]
		dict set maildata root [libdb get $myDb "ssmtp:root"]
		
		set dataDict [dict create \
			mail $mailList \
			maildata $maildata
		]
			  
		set mainDict [dict create \
			success true \
			data $dataDict]
				  
		HTML [::dict2json::compile_json \
			{dict data {dict mail {list {dict}} maildata {dict}}} $mainDict]
	
	} 
    libdb close $myDb

}; # namespace

exit 0
